//+------------------------------------------------------------------+
//|                                    i - American_Open_Close_2.mq4 |
//|                        Copyright 2013, MetaQuotes Software Corp. |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
#property copyright "Sashgrin"
#property link      ""

#property indicator_chart_window
//--- input parameters
extern int       _UTC = +2;
extern int       _ = 100;

extern bool _Open = True;
extern bool _Open = False;
extern bool _Level = False;
extern bool _Close = True;
extern bool _Close_1 = False;
extern bool _Level1 = True;

extern color _Amer_Open = DodgerBlue;
extern color _Amer_Close = FireBrick;
extern color _Amer_Close2 = Lime;
extern color _Eur_Open = MediumSeaGreen;
extern color _Amer_Close3 = Chocolate;

datetime new_bar;
string i_name = "i-Amer_OC";
string  o_name;


datetime T_0, T_1, day_00;
double price;

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
  for (int i = ObjectsTotal()-1; i >= 0; i--)     
      if ( StringSubstr(ObjectName(i), 0, StringLen(i_name)) == i_name)
         ObjectDelete(ObjectName(i)); 
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
{

if (new_bar == Time[0])   return(0); 
  else   new_bar = Time[0]; 

int limit = _;

// if (limit>100) limit=100;


int bar_0;

// Euro 8:00 - 16:30
// Amer 14:30 - 21:00 

for (int i=0; i<limit; i++)
{
//===  i -  

day_00 = iTime(NULL, PERIOD_D1, i) ; //  - 

//  
T_0 = day_00 + (8 + _UTC)*60*60 ; 
T_1 = T_0 + 8.5*60*60 ;

bar_0 = iBarShift(NULL, PERIOD_M15, T_0, true);
if ( bar_0 >= 0 ) 
  {
   price = iOpen(NULL, PERIOD_M15, bar_0);
   if (_Open) 
     Draw_Level("_E_Open_" + i, _Eur_Open, price);
   }

//  
T_0 = day_00 + (14.5+_UTC)*60*60 ; 
T_1 = T_0 + 23*60*60 ; //  + 6.5*60*60 ;

bar_0 = iBarShift(NULL, PERIOD_M15, T_0, true);
if ( bar_0 >= 0 ) 
  {
   price = iOpen(NULL, PERIOD_M15, bar_0);
   if (_Open) 
   {
         Draw_Level("_A_Open_" + i, _Amer_Open, price);
           if (_Level)    
     {
     Draw_Level("_A_Close_" + i + "V", _Amer_Close3, price+34*Point);
               Draw_Level("_A_Close_" + i + "N", _Amer_Close3, price-34*Point);
                    Draw_Level("_A_Close_" + i + "z", _Amer_Close3, price+55*Point);
                         Draw_Level("_A_Close_" + i + "x", _Amer_Close3, price-55*Point);
                              Draw_Level("_A_Close_" + i + "c", _Amer_Close3, price+89*Point);
                                   Draw_Level("_A_Close_" + i + "b", _Amer_Close3, price-89*Point);
                                   }
   }
   }

//  
T_0 = day_00 + (21+_UTC)*60*60 ; 
T_1 = T_0 + 24*60*60 ;
bar_0 = iBarShift(NULL, PERIOD_M15, T_0-15*60, true);
if ( bar_0 >= 0 ) 
  {
   price = iClose(NULL, PERIOD_M15, bar_0);
   if (_Close)
   {
     Draw_Level("_A_Close_" + i, _Amer_Close, price);
     if (_Level1) 
   {
          Draw_Level("_A_Close_" + i + "V", _Amer_Close3, price+34*Point);
               Draw_Level("_A_Close_" + i + "N", _Amer_Close3, price-34*Point);
                    Draw_Level("_A_Close_" + i + "z", _Amer_Close3, price+55*Point);
                         Draw_Level("_A_Close_" + i + "x", _Amer_Close3, price-55*Point);
                              Draw_Level("_A_Close_" + i + "c", _Amer_Close3, price+89*Point);
                                   Draw_Level("_A_Close_" + i + "b", _Amer_Close3, price-89*Point);
    }
    }                   
   }

//  
T_0 = day_00 + (6+_UTC)*60*60 ; 
T_1 = T_0 + 24*60*60 ;
bar_0 = iBarShift(NULL, PERIOD_M15, T_0-15*60, true);
if ( bar_0 >= 0 ) 
  {
   price = iClose(NULL, PERIOD_M15, bar_0);
   if (_Close_1) 
     Draw_Level("_A_Close1_" + i, _Amer_Close2, price);
   }



}



return(0);
}

//+------------------------------------------------------------------+

void Draw_Level(string name, color , double price1)
{
if (TimeDayOfWeek(T_1)==6)
  T_1 = T_1 + 2*24*60*60;

o_name = i_name + name;
if (ObjectFind(o_name) == -1)
  ObjectCreate(o_name,OBJ_TREND,0,T_0,price1,T_1,price1);   
ObjectSet(o_name,OBJPROP_COLOR, );
ObjectSet(o_name,OBJPROP_STYLE,STYLE_SOLID); // level_style
ObjectSet(o_name,OBJPROP_WIDTH,2);
ObjectSet(o_name, OBJPROP_TIME1, T_0);
ObjectSet(o_name, OBJPROP_TIME2, T_1);
ObjectSet(o_name, OBJPROP_PRICE1, price1);
ObjectSet(o_name, OBJPROP_PRICE2, price1);
ObjectSet(o_name,OBJPROP_RAY,false);
}